package com.chinaweal.aiccs.common.util;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.time.DayOfWeek;
import java.time.LocalDate;
import java.time.format.DateTimeFormatter;
import java.util.Calendar;
import java.util.Date;
import java.util.TimeZone;

/**
 * 日期处理工具类
 *
 * @author <a href="https://blog.lroyia.top">lroyia</a>
 * @since 2020/8/5 10:37
 **/
public abstract class DateUtils {

    /**
     * yyyy-MM-dd
     **/
    public static final String DATE_DEFAULT_FORMAT = "yyyy-MM-dd";

    /**
     * yyyy-MM-dd HH:mm:ss
     **/
    public static final String DATETIME_DEFAULT_FORMAT = "yyyy-MM-dd HH:mm:ss";

    /**
     * yyyyMMddHHmmss
     **/
    public static final String DATETIME_NOT_UNDERLINE_FORMAT = "yyyyMMddHHmmss";

    /**
     * yyyy-MM
     **/
    public static final String MONTH_DEFAULT_FORMAT = "yyyy-MM";

    private static SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");

    /**
     * 获取日期格式化字符串
     *
     * @param date   日期对象
     * @param format 格式化字符串
     * @return 格式化结果
     * @author lroyia
     * @since 2020年8月5日 10:39:24
     */
    public static String getDateFormat(Date date, String format) {
        if (date == null || StringUtils.isBlank(format)) return null;
        SimpleDateFormat sdf = new SimpleDateFormat(format);
        return sdf.format(date);
    }

    /**
     * 日期字符串转为日期对象
     *
     * @param dateStr 日期字符串
     * @param format  格式化字符串
     * @return 转换结果
     * @author lroyia
     * @since 2020年8月5日 10:41:49
     */
    public static Date parseDate(String dateStr, String format) {
        if (StringUtils.isBlank(dateStr) || StringUtils.isBlank(format)) return null;
        SimpleDateFormat sdf = new SimpleDateFormat(format);
        Date result = null;
        try {
            result = sdf.parse(dateStr);
        } catch (ParseException e) {
            e.printStackTrace();
        }
        return result;
    }

    /**
     * 带时区的时间参数转为yyyy-MM-dd HH:mm:ss格式
     * 例：2018-11-16T16:00:00.000Z --> 2018-11-16 16:00:00
     *
     * @param dateStr 时间字符串
     * @return
     * @throws ParseException
     */
    public static String dateTimeFormat(String dateStr) {
        if (StringUtils.isBlank(dateStr)) return null;
//        dateStr = dateStr.replace("Z","UTC");
        SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd'T'HH:mm:ss.SSS'Z'");
        format.setTimeZone(TimeZone.getTimeZone("UTC"));
        Date date = null;
        try {
            date = format.parse(dateStr);
        } catch (ParseException e) {
            e.printStackTrace();
        }
        format = new SimpleDateFormat(DATETIME_DEFAULT_FORMAT);
        return format.format(date);
    }

    /**
     * LocalDate转String
     *
     * @param localDate localDate日期对象
     * @param format    格式化字符串
     * @return
     */
    public static String localDateFormat(LocalDate localDate, String format) {
        if (localDate == null || StringUtils.isBlank(format)) return null;
        DateTimeFormatter df = DateTimeFormatter.ofPattern(format);
        return localDate.format(df);
    }

    /**
     * String转LocalDate
     *
     * @param localDateStr 日期格式字符串
     * @param format       格式化字符串
     * @return
     */
    public static LocalDate parseLocalDate(String localDateStr, String format) {
        if (StringUtils.isBlank(localDateStr) || StringUtils.isBlank(format)) return null;
        DateTimeFormatter df = DateTimeFormatter.ofPattern(format);
        LocalDate localDate = null;
        try {
            localDate = LocalDate.parse(localDateStr, df);
        } catch (Exception e) {
            e.printStackTrace();
        }
        return localDate;
    }

    /**
     * 获取当前时间之后n个工作日的日期
     *
     * @param holidays 节假日（日期格式：2019-01-01,2019-01-04,2019-01-05,......）
     * @param today    当前日期（日期格式：2019-01-01 08:08:08）
     * @param num      需要设置的n个工作日
     * @return
     * @throws Exception
     */
    public static String getWorkDayEnd(String holidays, String today, int num) throws Exception {
        // 转化为数组
//        String[] dayArr = holidays.split(",");
//        List<String> holidayList = new ArrayList<String>(Arrays.asList(dayArr));

        // 将字符串转换成日期
        Date date = sdf.parse(today);

        // 获取工作日
        Date workDay = getWorkDay(num, date);
        String workDayStr = sdf.format(workDay);

        return workDayStr;

    }

    /**
     * 获取工作日
     *
     * @param num 需要设置的n个工作日
     * @param day 目标日期
     * @return
     * @throws Exception
     */
    public static Date getWorkDay(int num, Date day) throws Exception {
        int delay = 1;
        while (delay <= num) {
            // 获取后一天日期
            Date endDay = getTomorrow(day);
            String time = sdf.format(endDay);

            //当前日期+1即tomorrow,判断是否是节假日,同时要判断是否是周末,都不是则将scheduleActiveDate日期+1,直到循环num次即可
            if (!isWeekend(time)) {
                delay++;
            }
//            else if (isWeekend(time)) {
//                System.out.println(time + "::是周末");
//            }
            day = endDay;
        }
        return day;
    }


    public static boolean isWeekend(String sdate) throws Exception {
        Date date = sdf.parse(sdate);
        Calendar cal = Calendar.getInstance();
        cal.setTime(date);
        if (cal.get(Calendar.DAY_OF_WEEK) == Calendar.SATURDAY || cal.get(Calendar.DAY_OF_WEEK) == Calendar.SUNDAY) {
            return true;
        } else {
            return false;
        }

    }

    /**
     * 获取后一天的日期
     *
     * @param date
     * @return
     */
    public static Date getTomorrow(Date date) {
        Calendar calendar = Calendar.getInstance();
        calendar.setTime(date);
        calendar.add(Calendar.DAY_OF_MONTH, +1);
        date = calendar.getTime();
        return date;
    }


    /**
     * 获取两个localDate相差几个工作日
     *
     * @param startDate
     * @param endDate
     * @return
     */
    public static int getDutyDays(LocalDate startDate, LocalDate endDate) {
        int result = 0;
        while (startDate.compareTo(endDate) < 0) {
            if (startDate.getDayOfWeek() != DayOfWeek.SATURDAY && startDate.getDayOfWeek() != DayOfWeek.SUNDAY) {
                result++;
            }
            startDate = startDate.plusDays(1);
        }

        return result;
    }

}
